<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { MessageBoxType } from '../components/MessageBox.vue'
import AppBox from '../layouts/AppBox.vue'

// using
const { t } = useI18n({
	messages: {
		en: {
			title: `Test Boxes Shared`,
			generic: `MessageBox`,
			close: `Close`,
			ok: `OK`,
			okCancel: `OK/Cancel`,
			yesNo: `Yes/No`,
			retryCancel: `Retry/Cancel`,
			simple: `MessageBox with Presets`,
			info: `Infomation`,
			warning: `Warning`,
			error: `Error`,
			question: `Question`,
			content: `Aaaa Bbbb Cccc Dddd\nใช่ใช่ใช่ใช่ ไม่ไม่ไม่ไม่\nYes Yes Yes Yes! No No No No!`,
			wait: `Waiting...`,
			waitAsync: `Waiting (Async)...`,
		},
		th: {
			title: `ทดสอบกล่องใช้ร่วมกัน`,
			generic: `กล่องข้อความ`,
			close: `ปิด`,
			ok: `ตกลง`,
			okCancel: `ตกลง/ยกเลิก`,
			yesNo: `ใช่/ไม่ใช่`,
			retryCancel: `ลองใหม่/ยกเลิก`,
			simple: `กล่องข้อความ พร้อมเซ็ตค่าเรียบร้อย`,
			info: `ข่าวสาร`,
			warning: `แจ้งเตือน`,
			error: `เกิดข้อผิดพลาด`,
			question: `คำถาม`,
			content: `ใช่ใช่ใช่ใช่ ไม่ไม่ไม่ไม่\nAaaa Bbbb Cccc Dddd\nใช่ ใช่ ใช่ ใช่! ไม่ ไม่ ไม่ ไม่!`,
			wait: `กรุณารอ...`,
			waitAsync: `กรุณารอ (Async)...`,
		},
	},
})

// states
const appBox = ref(<InstanceType<typeof AppBox> | null>null)

// ----------------------------------------------------------------------

function closed(result: boolean): void {
	console.log(`[callback shared] message box closed, result: ${result}`)
}

function open(caption: string, type: MessageBoxType, alternateFocus: boolean, barrierDismissible: boolean): void {
	appBox.value?.useMessageBox()?.open({
		caption,
		content: t('content'),
		type,
		alternateFocus,
		barrierDismissible,
		callback: closed,
	})
}

function info(): void {
	appBox.value?.useMessageBox()?.info(t('content'), closed)
}

function warning(): void {
	appBox.value?.useMessageBox()?.warning(t('content'), closed)
}

function error(): void {
	appBox.value?.useMessageBox()?.error(t('content'), closed)
}

function question(): void {
	appBox.value?.useMessageBox()?.question(t('content'), closed)
}

function wait(): void {
	const waitBox = appBox.value?.useWaitBox()
	if (waitBox && !waitBox.isOpen()) {
		waitBox.open({})
		let n = 0
		const timer = setInterval(() => {
			n++
			if (n >= 10) {
				clearInterval(timer)
				waitBox.close()
			}
		}, 500)
	}
}

function waitAsync(): void {
	const waitBox = appBox.value?.useWaitBox()
	if (waitBox && !waitBox.isOpen()) {
		waitBox.wait(async () => {
			await new Promise(r => setTimeout(r, 5000))
			return
		})
	}
}
</script>


<template>
	<AppBox ref="appBox" :title="t('title')">
		<Breadcrumbs :path="[
			[t('path.home'), '/'],
			[t('path.test-boxes-shared'), '#']]" />

		<section class="testset">
			<h1>{{ t('generic') }}</h1>
			<article class="flexbox">
				<button class="normal" @click.prevent="open(t('close'), MessageBoxType.close, false, true)">
					{{ t('close') }}</button>
				<button class="normal" @click.prevent="open(t('ok'), MessageBoxType.ok, false, true)">
					{{ t('ok') }}</button>
				<button class="normal" @click.prevent="open(t('okCancel'), MessageBoxType.okCancel, false, true)">
					{{ t('okCancel') }}</button>
				<button class="normal" @click.prevent="open(t('yesNo'), MessageBoxType.yesNo, true, false)">
					{{ t('yesNo') }}</button>
				<button class="normal" @click.prevent="open(t('retryCancel'), MessageBoxType.retryCancel, true, false)">
					{{ t('retryCancel') }}</button>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('simple') }}</h1>
			<article class="flexbox">
				<button class="normal" @click.prevent="info">
					<i class="material-symbols-outlined">info</i>
					<span>{{ t('info') }}</span>
				</button>
				<button class="normal" @click.prevent="warning">
					<i class="material-symbols-outlined">warning</i>
					<span>{{ t('warning') }}</span>
				</button>
				<button class="normal" @click.prevent="error">
					<i class="material-symbols-outlined">error</i>
					<span>{{ t('error') }}</span>
				</button>
				<button class="normal" @click.prevent="question">
					<i class="material-symbols-outlined">help</i>
					<span>{{ t('question') }}</span>
				</button>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('wait') }}</h1>
			<article class="flexbox">
				<button class="normal" @click.prevent="wait">{{ t('wait') }}</button>
				<button class="normal" @click.prevent="waitAsync">{{ t('waitAsync') }}</button>
			</article>
		</section>
	</AppBox>
</template>
